//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef WebRenderMessages_h
#define WebRenderMessages_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/gfx/Matrix.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/webrender/WebRenderTypes.h"
#include "mozilla/webrender/webrender_ffi.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/layers/LayersMessages.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalTransform|
//
namespace mozilla {
namespace layers {
class OptionalTransform final
{
public:
    enum Type {
        T__None,
        TMatrix4x4 = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::void_t void_t;
    typedef Matrix4x4 Matrix4x4__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Matrix4x4> VMatrix4x4;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    Matrix4x4*
    ptr_Matrix4x4()
    {
        return ((mValue).VMatrix4x4).addr();
    }
    const Matrix4x4*
    constptr_Matrix4x4() const
    {
        return ((mValue).VMatrix4x4).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalTransform() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalTransform(const Matrix4x4& aOther);

    MOZ_IMPLICIT OptionalTransform(Matrix4x4&& aOther);

    MOZ_IMPLICIT OptionalTransform(const void_t& aOther);

    MOZ_IMPLICIT OptionalTransform(void_t&& aOther);

    MOZ_IMPLICIT OptionalTransform(const OptionalTransform& aOther);

    MOZ_IMPLICIT OptionalTransform(OptionalTransform&& aOther);

    ~OptionalTransform();

    Type
    type() const
    {
        return mType;
    }

    OptionalTransform&
    operator=(const Matrix4x4& aRhs);

    OptionalTransform&
    operator=(Matrix4x4&& aRhs);

    OptionalTransform&
    operator=(const void_t& aRhs);

    OptionalTransform&
    operator=(void_t&& aRhs);

    OptionalTransform&
    operator=(const OptionalTransform& aRhs);

    OptionalTransform&
    operator=(OptionalTransform&& aRhs);

    bool
    operator==(const Matrix4x4& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalTransform& aRhs) const;

    Matrix4x4&
    get_Matrix4x4()
    {
        AssertSanity(TMatrix4x4);
        return (*(ptr_Matrix4x4()));
    }
    const Matrix4x4&
    get_Matrix4x4() const
    {
        AssertSanity(TMatrix4x4);
        return (*(constptr_Matrix4x4()));
    }
    void
    get(Matrix4x4* aOutValue) const;
    operator Matrix4x4&()
    {
        return get_Matrix4x4();
    }
    operator const Matrix4x4&() const
    {
        return get_Matrix4x4();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::OptionalTransform>
{
    typedef mozilla::layers::OptionalTransform paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalOpacity|
//
namespace mozilla {
namespace layers {
class OptionalOpacity final
{
public:
    enum Type {
        T__None,
        Tfloat = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::void_t void_t;
    typedef float float__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<float> Vfloat;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    float*
    ptr_float()
    {
        return ((mValue).Vfloat).addr();
    }
    const float*
    constptr_float() const
    {
        return ((mValue).Vfloat).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalOpacity() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalOpacity(const float& aOther);

    MOZ_IMPLICIT OptionalOpacity(float&& aOther);

    MOZ_IMPLICIT OptionalOpacity(const void_t& aOther);

    MOZ_IMPLICIT OptionalOpacity(void_t&& aOther);

    MOZ_IMPLICIT OptionalOpacity(const OptionalOpacity& aOther);

    MOZ_IMPLICIT OptionalOpacity(OptionalOpacity&& aOther);

    ~OptionalOpacity();

    Type
    type() const
    {
        return mType;
    }

    OptionalOpacity&
    operator=(const float& aRhs);

    OptionalOpacity&
    operator=(float&& aRhs);

    OptionalOpacity&
    operator=(const void_t& aRhs);

    OptionalOpacity&
    operator=(void_t&& aRhs);

    OptionalOpacity&
    operator=(const OptionalOpacity& aRhs);

    OptionalOpacity&
    operator=(OptionalOpacity&& aRhs);

    bool
    operator==(const float& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalOpacity& aRhs) const;

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    void
    get(float* aOutValue) const;
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::OptionalOpacity>
{
    typedef mozilla::layers::OptionalOpacity paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddExternalImage|
//
namespace mozilla {
namespace layers {
class OpAddExternalImage final
{
private:
    typedef mozilla::wr::ExternalImageId ExternalImageId;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpAddExternalImage() :
        externalImageId_(),
        key_()
    {
    }

    MOZ_IMPLICIT OpAddExternalImage(
            const ExternalImageId& _externalImageId,
            const ImageKey& _key) :
        externalImageId_(_externalImageId),
        key_(_key)
    {
    }

    bool
    operator==(const OpAddExternalImage& _o) const;

    bool
    operator!=(const OpAddExternalImage& _o) const;

    ExternalImageId&
    externalImageId()
    {
        return externalImageId_;
    }
    const ExternalImageId&
    externalImageId() const
    {
        return externalImageId_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    ExternalImageId externalImageId_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::OpAddExternalImage>
{
    typedef mozilla::layers::OpAddExternalImage paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddCompositorAnimations|
//
namespace mozilla {
namespace layers {
class OpAddCompositorAnimations final
{
private:
    typedef mozilla::layers::CompositorAnimations CompositorAnimations;
    typedef mozilla::layers::OptionalTransform OptionalTransform;
    typedef mozilla::layers::OptionalOpacity OptionalOpacity;

public:
    MOZ_IMPLICIT OpAddCompositorAnimations() :
        data_(),
        transform_(),
        opacity_()
    {
    }

    MOZ_IMPLICIT OpAddCompositorAnimations(
            const CompositorAnimations& _data,
            const OptionalTransform& _transform,
            const OptionalOpacity& _opacity) :
        data_(_data),
        transform_(_transform),
        opacity_(_opacity)
    {
    }

    bool
    operator==(const OpAddCompositorAnimations& _o) const;

    bool
    operator!=(const OpAddCompositorAnimations& _o) const;

    CompositorAnimations&
    data()
    {
        return data_;
    }
    const CompositorAnimations&
    data() const
    {
        return data_;
    }

    OptionalTransform&
    transform()
    {
        return transform_;
    }
    const OptionalTransform&
    transform() const
    {
        return transform_;
    }

    OptionalOpacity&
    opacity()
    {
        return opacity_;
    }
    const OptionalOpacity&
    opacity() const
    {
        return opacity_;
    }

private:
    CompositorAnimations data_;
    OptionalTransform transform_;
    OptionalOpacity opacity_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::OpAddCompositorAnimations>
{
    typedef mozilla::layers::OpAddCompositorAnimations paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUpdateAsyncImagePipeline|
//
namespace mozilla {
namespace layers {
class OpUpdateAsyncImagePipeline final
{
private:
    typedef mozilla::wr::PipelineId PipelineId;
    typedef mozilla::LayerRect LayerRect;
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::gfx::MaybeIntSize MaybeIntSize;
    typedef mozilla::wr::ImageRendering ImageRendering;
    typedef mozilla::wr::MixBlendMode MixBlendMode;

public:
    MOZ_IMPLICIT OpUpdateAsyncImagePipeline() :
        pipelineId_(),
        scBounds_(),
        scTransform_(),
        scaleToSize_(),
        filter_(),
        mixBlendMode_()
    {
    }

    MOZ_IMPLICIT OpUpdateAsyncImagePipeline(
            const PipelineId& _pipelineId,
            const LayerRect& _scBounds,
            const Matrix4x4& _scTransform,
            const MaybeIntSize& _scaleToSize,
            const ImageRendering& _filter,
            const MixBlendMode& _mixBlendMode) :
        pipelineId_(_pipelineId),
        scBounds_(_scBounds),
        scTransform_(_scTransform),
        scaleToSize_(_scaleToSize),
        filter_(_filter),
        mixBlendMode_(_mixBlendMode)
    {
    }

    bool
    operator==(const OpUpdateAsyncImagePipeline& _o) const;

    bool
    operator!=(const OpUpdateAsyncImagePipeline& _o) const;

    PipelineId&
    pipelineId()
    {
        return pipelineId_;
    }
    const PipelineId&
    pipelineId() const
    {
        return pipelineId_;
    }

    LayerRect&
    scBounds()
    {
        return scBounds_;
    }
    const LayerRect&
    scBounds() const
    {
        return scBounds_;
    }

    Matrix4x4&
    scTransform()
    {
        return scTransform_;
    }
    const Matrix4x4&
    scTransform() const
    {
        return scTransform_;
    }

    MaybeIntSize&
    scaleToSize()
    {
        return scaleToSize_;
    }
    const MaybeIntSize&
    scaleToSize() const
    {
        return scaleToSize_;
    }

    ImageRendering&
    filter()
    {
        return filter_;
    }
    const ImageRendering&
    filter() const
    {
        return filter_;
    }

    MixBlendMode&
    mixBlendMode()
    {
        return mixBlendMode_;
    }
    const MixBlendMode&
    mixBlendMode() const
    {
        return mixBlendMode_;
    }

private:
    PipelineId pipelineId_;
    LayerRect scBounds_;
    Matrix4x4 scTransform_;
    MaybeIntSize scaleToSize_;
    ImageRendering filter_;
    MixBlendMode mixBlendMode_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::OpUpdateAsyncImagePipeline>
{
    typedef mozilla::layers::OpUpdateAsyncImagePipeline paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebRenderParentCommand|
//
namespace mozilla {
namespace layers {
class WebRenderParentCommand final
{
public:
    enum Type {
        T__None,
        TOpAddExternalImage = 1,
        TOpUpdateAsyncImagePipeline,
        TCompositableOperation,
        TOpAddCompositorAnimations,
        T__Last = TOpAddCompositorAnimations
    };

private:
    typedef mozilla::layers::OpAddExternalImage OpAddExternalImage;
    typedef mozilla::layers::OpUpdateAsyncImagePipeline OpUpdateAsyncImagePipeline;
    typedef mozilla::layers::CompositableOperation CompositableOperation;
    typedef mozilla::layers::OpAddCompositorAnimations OpAddCompositorAnimations;
    typedef OpAddExternalImage OpAddExternalImage__tdef;
    typedef OpUpdateAsyncImagePipeline OpUpdateAsyncImagePipeline__tdef;
    typedef CompositableOperation CompositableOperation__tdef;
    typedef OpAddCompositorAnimations OpAddCompositorAnimations__tdef;

    union Value {
        mozilla::AlignedStorage2<OpAddExternalImage> VOpAddExternalImage;
        mozilla::AlignedStorage2<OpUpdateAsyncImagePipeline> VOpUpdateAsyncImagePipeline;
        mozilla::AlignedStorage2<CompositableOperation> VCompositableOperation;
        mozilla::AlignedStorage2<OpAddCompositorAnimations> VOpAddCompositorAnimations;
    };

    OpAddExternalImage*
    ptr_OpAddExternalImage()
    {
        return ((mValue).VOpAddExternalImage).addr();
    }
    const OpAddExternalImage*
    constptr_OpAddExternalImage() const
    {
        return ((mValue).VOpAddExternalImage).addr();
    }
    OpUpdateAsyncImagePipeline*
    ptr_OpUpdateAsyncImagePipeline()
    {
        return ((mValue).VOpUpdateAsyncImagePipeline).addr();
    }
    const OpUpdateAsyncImagePipeline*
    constptr_OpUpdateAsyncImagePipeline() const
    {
        return ((mValue).VOpUpdateAsyncImagePipeline).addr();
    }
    CompositableOperation*
    ptr_CompositableOperation()
    {
        return ((mValue).VCompositableOperation).addr();
    }
    const CompositableOperation*
    constptr_CompositableOperation() const
    {
        return ((mValue).VCompositableOperation).addr();
    }
    OpAddCompositorAnimations*
    ptr_OpAddCompositorAnimations()
    {
        return ((mValue).VOpAddCompositorAnimations).addr();
    }
    const OpAddCompositorAnimations*
    constptr_OpAddCompositorAnimations() const
    {
        return ((mValue).VOpAddCompositorAnimations).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebRenderParentCommand() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebRenderParentCommand(const OpAddExternalImage& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(OpAddExternalImage&& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const OpUpdateAsyncImagePipeline& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(OpUpdateAsyncImagePipeline&& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const CompositableOperation& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(CompositableOperation&& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const OpAddCompositorAnimations& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(OpAddCompositorAnimations&& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const WebRenderParentCommand& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(WebRenderParentCommand&& aOther);

    ~WebRenderParentCommand();

    Type
    type() const
    {
        return mType;
    }

    WebRenderParentCommand&
    operator=(const OpAddExternalImage& aRhs);

    WebRenderParentCommand&
    operator=(OpAddExternalImage&& aRhs);

    WebRenderParentCommand&
    operator=(const OpUpdateAsyncImagePipeline& aRhs);

    WebRenderParentCommand&
    operator=(OpUpdateAsyncImagePipeline&& aRhs);

    WebRenderParentCommand&
    operator=(const CompositableOperation& aRhs);

    WebRenderParentCommand&
    operator=(CompositableOperation&& aRhs);

    WebRenderParentCommand&
    operator=(const OpAddCompositorAnimations& aRhs);

    WebRenderParentCommand&
    operator=(OpAddCompositorAnimations&& aRhs);

    WebRenderParentCommand&
    operator=(const WebRenderParentCommand& aRhs);

    WebRenderParentCommand&
    operator=(WebRenderParentCommand&& aRhs);

    bool
    operator==(const OpAddExternalImage& aRhs) const;

    bool
    operator==(const OpUpdateAsyncImagePipeline& aRhs) const;

    bool
    operator==(const CompositableOperation& aRhs) const;

    bool
    operator==(const OpAddCompositorAnimations& aRhs) const;

    bool
    operator==(const WebRenderParentCommand& aRhs) const;

    OpAddExternalImage&
    get_OpAddExternalImage()
    {
        AssertSanity(TOpAddExternalImage);
        return (*(ptr_OpAddExternalImage()));
    }
    const OpAddExternalImage&
    get_OpAddExternalImage() const
    {
        AssertSanity(TOpAddExternalImage);
        return (*(constptr_OpAddExternalImage()));
    }
    void
    get(OpAddExternalImage* aOutValue) const;
    operator OpAddExternalImage&()
    {
        return get_OpAddExternalImage();
    }
    operator const OpAddExternalImage&() const
    {
        return get_OpAddExternalImage();
    }

    OpUpdateAsyncImagePipeline&
    get_OpUpdateAsyncImagePipeline()
    {
        AssertSanity(TOpUpdateAsyncImagePipeline);
        return (*(ptr_OpUpdateAsyncImagePipeline()));
    }
    const OpUpdateAsyncImagePipeline&
    get_OpUpdateAsyncImagePipeline() const
    {
        AssertSanity(TOpUpdateAsyncImagePipeline);
        return (*(constptr_OpUpdateAsyncImagePipeline()));
    }
    void
    get(OpUpdateAsyncImagePipeline* aOutValue) const;
    operator OpUpdateAsyncImagePipeline&()
    {
        return get_OpUpdateAsyncImagePipeline();
    }
    operator const OpUpdateAsyncImagePipeline&() const
    {
        return get_OpUpdateAsyncImagePipeline();
    }

    CompositableOperation&
    get_CompositableOperation()
    {
        AssertSanity(TCompositableOperation);
        return (*(ptr_CompositableOperation()));
    }
    const CompositableOperation&
    get_CompositableOperation() const
    {
        AssertSanity(TCompositableOperation);
        return (*(constptr_CompositableOperation()));
    }
    void
    get(CompositableOperation* aOutValue) const;
    operator CompositableOperation&()
    {
        return get_CompositableOperation();
    }
    operator const CompositableOperation&() const
    {
        return get_CompositableOperation();
    }

    OpAddCompositorAnimations&
    get_OpAddCompositorAnimations()
    {
        AssertSanity(TOpAddCompositorAnimations);
        return (*(ptr_OpAddCompositorAnimations()));
    }
    const OpAddCompositorAnimations&
    get_OpAddCompositorAnimations() const
    {
        AssertSanity(TOpAddCompositorAnimations);
        return (*(constptr_OpAddCompositorAnimations()));
    }
    void
    get(OpAddCompositorAnimations* aOutValue) const;
    operator OpAddCompositorAnimations&()
    {
        return get_OpAddCompositorAnimations();
    }
    operator const OpAddCompositorAnimations&() const
    {
        return get_OpAddCompositorAnimations();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::WebRenderParentCommand>
{
    typedef mozilla::layers::WebRenderParentCommand paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef WebRenderMessages_h
